# -*- coding: utf-8 -*-
from setuphelpers import *

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()

https://www.zabbix.com/documentation/current/en/manual/installation/install_from_packages/win_msi
"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
properties = {"SERVER": "server_fqdn"}


def install():

    for soft in installed_softwares("Zabbix Agent"):
        zabbix_folder = soft['install_location']
        zabbix_agentd = makepath(zabbix_folder,"zabbix_agentd.conf")
        if isfile(zabbix_agentd):
            with open(zabbix_agentd, 'r') as f:
                server = f.read().split('\nServer=')[1].split('\n')[0].strip()
                properties['SERVER'] = server
            break
    

    for soft in installed_softwares('Zabbix Agent'):
        if Version(soft['version']) < Version(control.get_software_version()):
            run(uninstall_cmd(soft['key']))

    # Declaring local variables
    bin_name = glob.glob("zabbix_agent-*.msi")[0]
    install_msi_if_needed(
        bin_name,
        min_version=control.get_software_version(),
        properties=properties,
    )
